// Hello World!

#include <string.h>  // our NDS library
#include <nds.h>  // our NDS library
#include <nds/arm9/console.h> //basic print funcionality
#include <stdio.h> //Standard Input Output library

#include "mplus_font_10x10.h"
#include "draw_font.h"


int main(void) {  // this is the start of our main function.
	int i;
	char name[21];
	uint16* buffer;
	u16 color;
	
	powerON(POWER_ALL);
	videoSetMode(MODE_FB0);
	vramSetBankA(VRAM_A_LCD);
	//videoSetMode(0);

	//videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE); //sub bg 0 will be used to print text
	//vramSetBankC(VRAM_C_SUB_BG);
	
	//lcdSwap();

/*
	SUB_BG0_CR = BG_MAP_BASE(31); //set the background to black.
	BG_PALETTE_SUB[255] = RGB15(31,31,31); //by default font will be rendered with color 255

	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	printf("Hello World!");  // At last! print Hello World on the screen.
	
	PERSONAL_DATA *pd = PersonalData;
	printf("nameLen = %d\n", pd->nameLen);
	//strcpy(name, pd->name);
	//name[pd->nameLen] = '\0';
	//printf("name = %s\n", i, name);
	
	for ( i = 0; i < pd->nameLen; i++ ) {
		printf("name[%d] = %4x\n", i, pd->name[i]);
	}
	
	
	color = 0x8141;
	printf("CHAR 0xe569 {\n");
	for ( i = 0; i < 11; i++ ) {
		printf("%d : %4x\n", i, FONT_MPLUS_10x10[0xe569][i]);
	}
	printf("}\n");
*/

	while(1) { // We have printed what we wnated; we now need to wait forever (or until you switch off)
	
		
		color = RGB15(31,31,31);
		buffer = VRAM_A;
		
		/*for (i = 0; i < 230; i++ ) {
			buffer++;
			*buffer = color;
		}*/
		drawFont(10,10,VRAM_A,'t',color);
		drawFont(20,10,VRAM_A,'H',color);
		drawFont(30,10,VRAM_A,'',color);
		drawFont(40,10,VRAM_A,'g',color);
		drawFont(50,10,VRAM_A,'o',color);
		drawFont(60,10,VRAM_A,'',color);
		drawFont(70,10,VRAM_A,'[',color);
		
		drawFont(10,30,VRAM_A,'',color);
		drawFont(20,30,VRAM_A,'',color);
		drawFont(30,30,VRAM_A,'[',color);
		
		drawFont(10,40,VRAM_A,'',color);
		drawFont(20,40,VRAM_A,'',color);
		drawFont(30,40,VRAM_A,'',color);
		drawFont(40,40,VRAM_A,'',color);
		drawFont(50,40,VRAM_A,'',color);
		drawFont(60,40,VRAM_A,'',color);
		drawFont(70,40,VRAM_A,'',color);
		drawFont(80,40,VRAM_A,'',color);
		drawFont(90,40,VRAM_A,'',color);
		drawFont(100,40,VRAM_A,'o',color);
		drawFont(110,40,VRAM_A,'',color);
		drawFont(120,40,VRAM_A,'',color);
		drawFont(130,40,VRAM_A,'B',color);
		
		drawFont(10,60,VRAM_A,'',color);
		drawFont(20,60,VRAM_A,'',color);
		drawFont(30,60,VRAM_A,'L',color);
		drawFont(40,60,VRAM_A,'',color);
		drawFont(50,60,VRAM_A,'',color);
		
		drawFont(10,80,VRAM_A,'',color);
		drawFont(20,80,VRAM_A,'`',color);
		drawFont(30,80,VRAM_A,'',color);
		
		drawFont(10,90,VRAM_A,0x41,color);
		drawFont(20,90,VRAM_A,'a',color);
		swiWaitForVBlank();
	} // this is the end of our while loop
	return 0;  // this says if we ever get here, return the value 0 (but we never do get here...)
} // this is the end of our main function

